
// Edité avec le créateur de plugin MuseScore3
// Michel Come (Novembre 2019)

import QtQuick 2.0
import MuseScore 3.0


MuseScore   {
   version: "3.0"
   description: "Tablature d'accordéon diatonique Sol/Do"
   menuPath: 'Plugins.Tablature pour diato Sol/Do'
   onRun:         {
                  var Curseur = curScore.newCursor();
                  Curseur.rewind(0);
                  
                  var Pous = 2.5;
                  var Tire = 5.0;
                  var Sens = 0;
                  
                  if (typeof curScore === 'undefined')Qt.quit();
                  
                  // indication des lignes pousser et tirer (P / T)
                  var PT = newElement(Element.STAFF_TEXT);
                  Curseur.add(PT) ;
                  PT.fontSize = 14 ;
                  PT.sizeSpatiumDependent = false;
                  PT.text = "P\nT" ;
                  PT.autoplace = false ;
                  PT.placement = Placement.BELOW ;
                  PT.offsetY = Pous ;
                  PT.offsetX = - 7 ;

                  //Si la partition est écrite en Do
                  if(curScore.keysig === 0)
                        {
                        console.log("Tonalité: Do");
                        while (Curseur.segment)
                              {
                              var Numero = newElement(Element.STAFF_TEXT);
                              if (Curseur.element && Curseur.element.type === Element.CHORD)
                                    {
                                    var Midi = Curseur.element.notes[0].pitch;
                                    // Transposer ici pour les diatos Ré/Sol
                                    //Midi = Midi + 5;
                                    switch (Midi)
                                          {
                                          case 52: Numero.text = "1'"; Sens = Pous ; break ;
                                          case 53: Numero.text = "1'"; Sens = Tire ; break ;
                                          case 55: Numero.text = "2'"; Sens = Pous ; break ;
                                          case 57: Numero.text = "3" ; Sens = Tire ; break ;
                                          case 59: Numero.text = "2'"; Sens = Tire ; break ;
                                          case 60: Numero.text = "3'"; Sens = Pous ; break ;
                                          case 62: Numero.text = "3'"; Sens = Tire ; break ;
                                          case 64: Numero.text = "4'"; Sens = Pous ; break ;
                                          case 65: Numero.text = "4'"; Sens = Tire ; break ;
                                          case 67: Numero.text = "5'"; Sens = Pous ; break ;
                                          case 69: Numero.text = "5'"; Sens = Tire ; break ;
                                          case 71: Numero.text = "6'"; Sens = Tire ; break ;
                                          case 72: Numero.text = "6'"; Sens = Pous ; break ;
                                          case 74: Numero.text = "7'"; Sens = Tire ; break ;
                                          case 76: Numero.text = "7'"; Sens = Pous ; break ;
                                          case 77: Numero.text = "8'"; Sens = Tire ; break ;
                                          case 79: Numero.text = "8'"; Sens = Pous ; break ;
                                          case 81: Numero.text = "9'"; Sens = Tire ; break ;
                                          case 83: Numero.text = "10'"; Sens = Tire ; break ;
                                          case 84: Numero.text = "9'"; Sens = Pous ; break ;
                                          case 86: Numero.text = "11"; Sens = Pous ; break ;
                                          case 88: Numero.text = "10'"; Sens = Pous ; break ;
                                          }
                                    }
                              Numero.autoplace = false ;
                              Curseur.add(Numero) ;
                              Numero.placement = Placement.BELOW ;
                              Numero.offsetY = Sens ;
                              Curseur.next();      
                              }
                        }
                  //Si la partition est écrite en Sol
                  if(curScore.keysig === 1)
                        {
                        console.log("Tonalité: Sol");
                        while (Curseur.segment)
                              {
                              var Numero = newElement(Element.STAFF_TEXT);
                              if (Curseur.element && Curseur.element.type === Element.CHORD)
                                    {
                                    var Midi = Curseur.element.notes[0].pitch;
                                    // Transposer ici pour les diatos Ré/Sol
                                    //Midi = Midi + 5;
                                    switch (Midi)
                                          {
                                          case 50: Numero.text = "2"; Sens = Pous ; break ;
                                          case 52: Numero.text = "1"; Sens = Tire ; break ;
                                          case 54: Numero.text = "2"; Sens = Tire ; break ;
                                          case 55: Numero.text = "3"; Sens = Pous ; break ;
                                          case 57: Numero.text = "3"; Sens = Tire ; break ;
                                          case 59: Numero.text = "4"; Sens = Pous ; break ;
                                          case 60: Numero.text = "4"; Sens = Tire ; break ;
                                          case 62: Numero.text = "5"; Sens = Pous ; break ;
                                          case 64: Numero.text = "5"; Sens = Tire ; break ;
                                          case 66: Numero.text = "6"; Sens = Tire ; break ;
                                          case 67: Numero.text = "6"; Sens = Pous ; break ;
                                          case 69: Numero.text = "7"; Sens = Tire ; break ;
                                          case 71: Numero.text = "7"; Sens = Pous ; break ;
                                          case 72: Numero.text = "8"; Sens = Tire ; break ;
                                          case 74: Numero.text = "8"; Sens = Pous ; break ;
                                          case 76: Numero.text = "9"; Sens = Tire ; break ;
                                          case 78: Numero.text = "10"; Sens = Tire ; break ;
                                          case 79: Numero.text = "9"; Sens = Pous ; break ;
                                          case 81: Numero.text = "11"; Sens = Tire ; break ;
                                          case 83: Numero.text = "10"; Sens = Pous ; break ;
                                          case 84: Numero.text = "9'"; Sens = Pous ; break ;
                                          case 86: Numero.text = "11'"; Sens = Pous ; break ;
                                          case 88: Numero.text = "10'"; Sens = Pous ; break ;
                                          }
                                    }
                              Numero.autoplace = false ;
                              Curseur.add(Numero) ;
                              Numero.placement = Placement.BELOW ;
                              Numero.offsetY = Sens ;
                              Curseur.next();      
                              }
                        }
                  Qt.quit();
                  }
            }